/*-
 * Copyright (C) @BABOLO  2005 Nov 7
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: cpy.cc,v 1.3 2005/11/17 21:17:45 babolo Exp $
 */

/***************************************************/
/*     codex.cpy()       */
/***************************************************/

static int
cpyc(ISO8583_Pack *pack, int fno, u_char *vly, ssize_t l) {
    int len = pack->package->fld[fno].len;
    u_char *ref = pack->refo[fno];
    if  (len < l) {
        ifBLIN_QV3(pack->flags) warnx("ISO8583_Cpy: too long(%d) string [%d]", l, fno);
        errno = EOVERFLOW;
        l = 0;
    } else {
        bzero(ref, len);
        memmove(ref, vly, l);
        l = len;
    }
    return(l);
}

static int
cpyl(ISO8583_Pack *pack, int fno, u_char *vly, ssize_t l) {
    int len = pack->package->fld[fno].len;
    u_char *ref = pack->refo[fno];
    int y = lv(0, 2, ref);

    if  (len < l) {
        ifBLIN_QV3(pack->flags) warnx("ISO8583_Cpy: too long string [%d]", fno);
        errno = EOVERFLOW;
        l = 0;
    } else if (y && (l != y)) {
        ifBLIN_QV3(pack->flags) warnx("ISO8583_Cpy: length mismatch (%d): %d<>%d", len, y, l);
        errno = EINVAL;
        l = 0;
    } else if (av(0, 2, ref++, (u_int64_t)l) > 2) {
        ifBLIN_QV3(pack->flags) warnx("ISO8583_Cpy: too big length %u", l);
        errno = EINVAL;
        l = 0;
    } else {
        memmove(ref, vly, l++);
    }
    return(l);
}
